/*
 * KernelConf - A Linux Kernel Configuration System
 *
 * Distributed under GNU General Public Lisence
 *
 * Copyright (C) 2002 by Anuradha Ratnaweera
 */

#ifndef _KCONF_TREE_H
#define _KCONF_TREE_H

/* search types */
#define NODE_SEARCH      1
#define NODE_INSERT      2
#define NODE_MARK_INSERT 3

/* node flags */
/* two bits for balance factor */
#define NODE_FLAGS_BF    3
#define NODE_FLAGS_MARK  4

typedef struct _Node* NodePtr;

typedef struct _Node {
    char *key;
    NodePtr left, right, next;
    char flags;
} Node;

NodePtr search_tree(NodePtr*, char*, int, size_t, NodePtr);

#endif /* _KCONF_TREE_H */
